## Calibration plots a la Steyerberg
source("C:/Users/Allison/Dropbox/UW/RA/Analyses/review_paper/val.prob.ci.June09.r")

library(MASS)
library(rms)

png("C:/Users/Allison/Dropbox/UW/RA/Analyses/review_paper/4calib_plots_Steyerberg.png",width=9.5,height=9,units="in",res=200)
par(mfrow=c(2,2))
set.seed(4875920)
prev=0.45 # prevalence in the paper was 55%
n=600
ORx=2.6; ORy=0.85; ORz=2; ORw=2.5; OR0a=1; OR0b=1; OR0c=1; OR0d=1
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]), c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                            1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

f<-lrm(X1~.,data=alldat)

prev=0.5 # prevalence in the paper was 55%
n=300
ORx=2.55; ORy=0.8; ORz=1.97; ORw=2.5; OR0a=1; OR0b=1; OR0c=1; OR0d=1
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]), c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                            1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

val.prob.ci(predict(f,alldat,type="fitted"),alldat[,1],m=30,statloc=FALSE)

set.seed(68709450)
prev=0.6 # prevalence in the paper was 55%
n=400
ORx=3.0; ORy=0.9; ORz=1.9; ORw=2.2; OR0a=1; OR0b=1; OR0c=1; OR0d=1
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]), c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                            1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

f<-lrm(X1~.,data=alldat)

prev=0.45 # prevalence in the paper was 55%
n=200
ORx=3.2; ORy=0.9; ORz=2.2; ORw=2.4; OR0a=1; OR0b=1.1; OR0c=1; OR0d=1
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1.5,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,0.8,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1.5),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]),  c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                             1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1.5,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,0.8,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1.5),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

val.prob.ci(predict(f,alldat,type="fitted"),alldat[,1],m=20,statloc=FALSE)




set.seed(68709450)
prev=0.5 # prevalence in the paper was 55%
n=600
ORx=3.8; ORy=0.8; ORz=1.97; ORw=2.3; OR0a=1; OR0b=1; OR0c=1; OR0d=1
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(0.9,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]), c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                            1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0,0,0,0,0,0,0,
                                                  0,1,0,0,0,0,0,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

f<-lrm(X1~.,data=alldat)

prev=0.5 # prevalence in the paper was 55%
n=200
ORx=2.98; ORy=0.89; ORz=1.78; ORw=2.37; OR0a=1; OR0b=1; OR0c=1; OR0d=1.8
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(0.89,0,0,0,0,0,0,0.15,
                                                  0,1,0,0,0,0,0.1,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0.1,0,0,0,0,1,0,
                                                  0.15,0,0,0,0,0,0,1),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]),  c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                             1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0,0,0,0,0,0,0.1,
                                                  0,1,0,0,0,0,0.1,0,
                                                  0,0,1,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0.1,0,0,0,0,1,0,
                                                  0.1,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

val.prob.ci(predict(f,alldat,type="fitted"),alldat[,1],m=20,statloc=FALSE)


set.seed(5849061)
prev=0.4 # prevalence in the paper was 55%
n=400
ORx=2.4; ORy=0.7; ORz=2.0; ORw=2.2; OR0a=0.3; OR0b=1.1; OR0c=1.15; OR0d=1.05
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(0,2,0,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(0.8,-0.01,0.1,0,0,0,0.2,0.1,
                                                  -0.01,1.1,0,0,0,0,0,0,
                                                  0.1,0,0.9,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,0.9,0,0,0,
                                                  0,0,0,0,0,1,0,0.1,
                                                  0.2,0,0,0,0,0,1,0,
                                                  0.1,0,0,0,0,0.1,0,1),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]), c(0+log(ORx),2+log(ORy),0+log(ORz),
                                                            1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0.1,0.2,0,0,0,0.05,0,
                                                  0.1,1.05,0,0,0,0,0,0,
                                                  0.2,0,0.95,0,0,0,0,0,
                                                  0,0,0,1.05,0,0,0,0,
                                                  0,0,0,0,0.9,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0.05,0,0,0,0,0,1,0,
                                                  0,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

f<-lrm(X1~.,data=alldat)

prev=0.6 # prevalence in the paper was 55%
n=150
ORx=1; ORy=0.4; ORz=2.6; ORw=2.9; OR0a=0.45; OR0b=1.4; OR0c=0.9; OR0d=1
d<-rbinom(n,1,prev)
d0<-cbind(rep(0,length(d[d==0])),mvrnorm(length(d[d==0]), c(1,2,0.5,1.5,.5,.75,0.5,0.75), 
                                         matrix(c(1,0.4,0.2,0,0,0,0,0,
                                                  0.4,1,0,0,0,0,0,0,
                                                  0.2,0,1.2,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1.4,0,
                                                  0,0,0,0,0,0,0,1.2),nrow=8,byrow=T)))
d1<-cbind(rep(1,length(d[d==1])),mvrnorm(length(d[d==1]), c(1+log(ORx),2+log(ORy),0.5+log(ORz),
                                                            1.5+log(ORw),.5+log(OR0a),.75+log(OR0b),0.5+log(OR0c),0.75+log(OR0d)), 
                                         matrix(c(1,0.3,0,0,0.1,0,0,0.2,
                                                  0.3,1,0,0,0,0,0,0,
                                                  0,0,1.3,0,0,0,0,0,
                                                  0,0,0,1,0,0,0,0,
                                                  0.1,0,0,0,1,0,0,0,
                                                  0,0,0,0,0,1,0,0,
                                                  0,0,0,0,0,0,1.5,0,
                                                  0.2,0,0,0,0,0,0,1),nrow=8,byrow=T)))
alldat<-data.frame(rbind(d0,d1))

val.prob.ci(predict(f,alldat,type="fitted"),alldat[,1],m=15,statloc=FALSE)

dev.off()
